summarylogtreecommitdiffstats
path: root/ccache.sh.in
diff options
context:
space:
mode:
Diffstat (limited to 'ccache.sh.in')
-rw-r--r--ccache.sh.in46
1 files changed, 46 insertions, 0 deletions
diff --git a/ccache.sh.in b/ccache.sh.in
new file mode 100644
index 00000000000..8d9e0b5e0db
--- /dev/null
+++ b/ccache.sh.in
@@ -0,0 +1,46 @@
+#!/usr/bin/bash
+#
+# ccache.sh - Cache compiliations and recycle them to save time on repititions
+#
+# Copyright (c) 2008-2016 Pacman Development Team <pacman-dev@archlinux.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+[[ -n "$LIBMAKEPKG_CCACHE_SH" ]] && return
+LIBMAKEPKG_CCACHE_SH=1
+
+LIBRARY=${LIBRARY:-'@libmakepkgdir@'}
+
+source "$LIBRARY/util/message.sh"
+source "$LIBRARY/util/option.sh"
+
+build_options+=('ccache')
+
+local ccache=0
+
+ccache() {
+
+ # use ccache if it is requested (check buildenv and PKGBUILD opts)
+ if check_buildoption "ccache" "y"; then
+ if ! type -p ccache >/dev/null; then
+ error "$(gettext "Cannot find the %s binary required for compiler cache usage.")" "ccache"
+ return 1
+ fi
+ if [ -d /usr/lib/ccache/bin ]; then
+ export PATH="/usr/lib/ccache/bin:$PATH"
+ ccache=1
+ fi
+ fi
+}